CREATE TRIGGER DEV_DEL_TRIG FOR DEVIATIONS
ACTIVE BEFORE DELETE POSITION 0
AS
BEGIN
	IF (OLD.DV_ID=1) THEN
		EXCEPTION RAISE_DEL_DEV_SICKLIST;
END
{***}
CREATE TRIGGER DS_ID_TRIG FOR DAYSCH
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.DS_ID IS NULL) THEN
  SELECT MAX(DS_ID)+1 FROM DAYSCH INTO NEW.DS_ID;
  IF (NEW.DS_ID IS NULL) THEN
      NEW.DS_ID=1;
  if (new.ds_number is null) then
  SELECT NUM FROM GET_DAY_NUMBER(NEW.DS_CT_ID) INTO NEW.DS_NUMBER;
  IF (NEW.DS_NUMBER>255) THEN
    EXCEPTION RAISE_INVALID_NUMBER;
END
{***}
CREATE TRIGGER AEXT_ADDTYPE_TRIG FOR ACR$EXTENSIONS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.EXT_DEF>1)
  then new.EXT_Type='G';
END
{***}
CREATE TRIGGER AEXT_ADDEXT_TRIG FOR ACR$EXTENSIONS
ACTIVE AFTER INSERT POSITION 1
AS
DECLARE VARIABLE I INTEGER;
BEGIN
 IF (NEW.EXT_DEF=2)
 THEN BEGIN
    NEW.EXT_TYPE='G';
    I=1;
    WHILE (I<3) DO
    BEGIN
      INSERT INTO ACR$EXTENSIONS
                   (EXT_ACR_ID,
                    EXT_TYPE,
                    EXT_NUMBER,
                    EXT_STUBS,
                    EXT_NAME,
                    EXT_SCD_ID,
                    EXT_ARCHIVE,
                    EXT_DEF)
      VALUES (NEW.EXT_ACR_ID,
              NEW.EXT_TYPE,
              NEW.EXT_NUMBER+:I,
              NEW.EXT_STUBS,
              NEW.EXT_NAME,
              NEW.EXT_SCD_ID,
              NEW.EXT_ARCHIVE,
              2+:I);
      I=I+1;
    END
  END
END
{***}
CREATE TRIGGER AEXT_STATE_TRIG FOR ACR$EXTENSIONS
ACTIVE AFTER INSERT POSITION 1
AS
DECLARE VARIABLE I INTEGER;
BEGIN
  DELETE FROM ACR$EXTSTATES WHERE
        EXT_ID=NEW.EXT_ID;
  INSERT INTO ACR$EXTSTATES(EXT_ID)
        VALUES(NEW.EXT_ID);
  DELETE FROM ACR$STUBS WHERE
        STB_EXT_ID=NEW.EXT_ID;
  DELETE FROM ACR$DIVEXTDEF WHERE
        DXD_EXT_ID=NEW.EXT_ID;
  I=0;
  WHILE (I<8)
  DO BEGIN
       INSERT INTO ACR$STUBS(STB_EXT_ID, STB_NUMBER)
       VALUES(NEW.EXT_ID, :I);
       IF ((NEW.EXT_DEF=4) AND (I=6))
       THEN  I=I+2;
       ELSE I=I+1;
     END
  I=0;
  IF ((NEW.EXT_DEF<3) or (NEW.EXT_DEF>4) or (new.ext_def is null))
  THEN BEGIN
         IF (NEW.EXT_TYPE='G')
         THEN BEGIN
                WHILE (I<8)
                DO BEGIN
                     INSERT INTO ACR$DIVEXTDEF(DXD_EXT_ID, DXD_RECORD, DXD_FLAG)
                     VALUES(NEW.EXT_ID, :I, "D");
                     I=I+1;
                   END
                I=0;
                WHILE (I<31)
                DO BEGIN
                     INSERT INTO ACR$DIVEXTDEF(DXD_EXT_ID, DXD_RECORD, DXD_FLAG)
                     VALUES(NEW.EXT_ID, :I, "U");
                     I=I+1;
                   END
              END
         ELSE BEGIN
                I=0;
                WHILE (I<2)
                DO BEGIN
                     INSERT INTO ACR$DIVEXTDEF(DXD_EXT_ID, DXD_RECORD, DXD_FLAG)
                     VALUES(NEW.EXT_ID, :I, "D");
                     I=I+1;
                   END
                I=1;
                WHILE (I<31)
                DO BEGIN
                     INSERT INTO ACR$DIVEXTDEF(DXD_EXT_ID, DXD_RECORD, DXD_FLAG)
                     VALUES(NEW.EXT_ID, :I, "U");
                     I=I+1;
                   END
              END
       END
END
{***}
CREATE TRIGGER ADXD_ADD23_TRIG FOR ACR$DIVEXTDEF AFTER INSERT POSITION 0 AS
DECLARE VARIABLE DEF INTEGER;
DECLARE VARIABLE I INTEGER;
BEGIN
  FOR SELECT EXT_DEF
      FROM ACR$EXTENSIONS
      WHERE EXT_ID=NEW.DXD_EXT_ID
      INTO :DEF
  DO BEGIN
  IF (:DEF=2)
  THEN BEGIN 
         I=1;
         WHILE (:I<3)
         DO BEGIN
              INSERT INTO ACR$DIVEXTDEF(DXD_DIV_ID,
                                   DXD_EXT_ID,
                                   DXD_RECORD,
                                   DXD_NAME,
                                   DXD_CODE,
                                   DXD_FLAG,
                                   DXD_STATE,
                                   DXD_ARCHIVE)
                            VALUES(NEW.DXD_DIV_ID,
                                   NEW.DXD_EXT_ID+:I,
                                   NEW.DXD_RECORD,
                                   NEW.DXD_NAME,
                                   NEW.DXD_CODE,
                                   NEW.DXD_FLAG,
                                   NEW.DXD_STATE,
                                   NEW.DXD_ARCHIVE);
              I=I+1;
            END
       END
 END
END
{***}
delete from daysch where ds_number = 0;
{***}
DROP TRIGGER CT_STATES_TRIG 
{***}
CREATE TRIGGER CT_STATES_TRIG FOR CONTROLLERS
ACTIVE AFTER INSERT POSITION 0
AS
 DECLARE VARIABLE I INTEGER;
BEGIN
  Insert into CtStates(CT_ID) VALUES (NEW.CT_ID);
  I=0;
   WHILE (I<64) DO
    BEGIN
      INSERT INTO  TIMERS(
      TM_CT_ID, TM_NO)
      VALUES (NEW.CT_ID,:I);
      I=I+1;
    END
END
{***}
CREATE TRIGGER TM_ID_TRIG FOR TIMERS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
 NEW.TM_ID=gen_id(TM_ID_GEN,1);
END
